   PROCESSOR 6502
   ORG $8000

      jmp .Start_Code
.TempData  dc.b  #$00
.TempByte1 dc.b  #$00
.TempByte2 dc.b  #$00
.TempByte3 dc.b  #$00
.TempByte4 dc.b  #$00
;--------------------
.EnglishIntro
           ;1234567891123456789212345678931
   INCLUDE TextCat.asm
      dc.b #$0D,#$0A,#$24
.EnglishResults
;      dc.b #$0D,#$0A
      dc.b "                                "
      dc.b "                                "
      dc.b "                               $"
      dc.b #$00


.ResultsScreen
      dc.b #$0D,#$0A
   INCLUDE  Results.asm
      dc.b #$0D,#$0A,#$24

.WarningText
     dc.b  "ERROR:Use only in English mode!"
   dc.b #$0D,#$0A,#$24

.DecodedText
      dc.b #$0D,#$0A
      dc.b #$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00
      dc.b #$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00
      dc.b #$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00
      dc.b #$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00,#$00

;-----------------------------------------------------------------
;-----------------------------------------------------------------
;=================================================================
;
; Here are two subroutines that convert bytes into printable text.
;
;-----------------------------------------------------------------
.GetHiNybble   lsr      ;Gives you the high nybble...
      lsr
      lsr
      lsr
.GetLoNybble   and #$f  ;Gives you the low nybble...
      clc
      adc #$30       ;And converts to a printable number
      cmp #$3a
      bcc .lbl_8154  ;Or HEX, if it's above 9.
.lbl_8151   clc
      adc #$7
.lbl_8154
      rts
;=================================================================
;-----------------------------------------------------------------
;-----------------------------------------------------------------

;The REAL start of the program...
;--------------------------------

.Start_Code
      cli
      lda #$b              ;Command #$0B???
      ldx #$0              ;A command?
      jsr $F80C            ;English or Chinese???     Hasta be English!
      and #$80             ;Test high bit of result???
      beq   .ItsEnglish

      lda   #$04
      ldx   #>.WarningText
      ldy   #<.WarningText
      jsr   $F80C
      jmp   .Quit_Program

.ItsEnglish

      lda #$4              ;Command #$04??  Write text???
      ldx #>.EnglishIntro
      ldy #<.EnglishIntro          ;Address to load the English Text ($8003)....
      jsr $F80C            ;Send command...
.lbl_8172
      lda #$18
      ldx #$0
      jsr $F800            ;Hmmm... what does this do?
                           ;It seems to get the raw keyboard data in A and X!!!
      tay
      cpy #$1b
      bne .Not_Escape
      cpx #$1
      bne .Not_Escape        ;If it isn't equal to "ESC", then continue....
      lda #$18
      ldx #$2
      jsr $F800            ;Hmm... get more keyboard data?
      and #$4
      beq .DontQuit_Program    ;If #%00000100, then QUIT! (?)
                           ;Must mean that CTRL is pressed at the same time...?
      jmp   .Quit_Program
.DontQuit_Program
      ldy #$1b             ;Heh.. puts the correct bytes back secretly..
      ldx #$1              ;This looks like a hack to me...
;--------------------------------------------------------------------
.Not_Escape
      cpy   #$00           ;Check to see if it's "ALT-F10"
      bne   .lbl_8172
      cpx   #$71
      bne   .lbl_8172      ;If not, keep searching...

      ldx   #$00
      stx   .TempData
.DoLoop
      lda   #$18
      ldx   #$00
      ldy   #$00
      jsr   $F800


      ldx   .TempData
      ldy   #$00
      sta   .EnglishResults,X
      inc   .TempData

      cmp   #$0D
      beq   .Finished
      tax
      lda   #$02
      ldy   #$00
      jsr   $F80C
      jmp   .DoLoop

.Finished

;      ldx   #$00
;.PrinterTestA
;      lda   $4185
;      bmi   .PrinterTestA
;.SendLoopA
;      lda   .EnglishResults,X
;      jsr   .GetHiNybble
;      sta   $4184
;      ldy   #$21
;      sty   $4186
;      dey
;      sty   $4186
;      lda   .EnglishResults,X
;      jsr   .GetLoNybble
;      sta   $4184
;      ldy   #$21
;      sty   $4186
;      dey
;      sty   $4186
;      inx
;      beq   .DonePrintingA
;      jmp   .PrinterTestA
;.DonePrintingA



      ldx   #$00
      ldy   #$00
.Decoding_Loop    ;OK, assume it's good!
      lda   .EnglishResults,X
      bne   .CheckCR
      lda   #$FF
      sta   .EnglishResults,X
      jmp   .FinishedDecoding
.CheckCR
      cmp   #$0D
      bne   .CheckLF
      lda   #$FE
      sta   .EnglishResults,X
      jmp   .FinishedDecoding
.CheckLF
      cmp   #$0A
      bne   .LookupPeriod
      lda   #$FD
      sta   .EnglishResults,X
      jmp   .FinishedDecoding
.LookupPeriod
      cmp   #$2E           ;Period?
      bne   .LookupMinus
      lda   #$FC
      jmp   .DoneLookup
.LookupMinus
      cmp   #$2D        ;Minus?
      bne   .LookupPlus
      lda   #$3F
      jmp   .DoneLookup
.LookupPlus
      cmp   #$2B        ;Plus?
      bne   .LookupComma
      lda   #$3E
      jmp   .DoneLookup
.LookupComma
      cmp   #$2C        ;Comma?
      bne   .LookupSlash
      lda   #$3E
      jmp   .DoneLookup
.LookupSlash
      cmp   #$2F        ;Slash?
      bne   .LookupLowerCase
      lda   #$3F
      jmp   .DoneLookup
.LookupLowerCase
      cmp   #$61        ;Lowercase a?
      bcc   .LookupUpperCase
      sec
      sbc   #$61              ;Go to #$00-19
      jmp   .DoneLookup
.LookupUpperCase
      cmp   #$41        ;Uppercase A?
      bcc   .LookupNumbers
      sec
      sbc   #$27              ;Go to #$1A-#$33
      jmp   .DoneLookup
.LookupNumbers                ;I'll assume it's now just numbers...
      clc
      adc   #$04              ;That was easy...
.DoneLookup
      sta   .EnglishResults,X
      inx
      jmp   .Decoding_Loop

.FinishedDecoding

;      ldx   #$00
;.PrinterTestA
;      lda   $4185
;      bmi   .PrinterTestA
;.SendLoopA
;      lda   .EnglishResults,X
;      jsr   .GetHiNybble
;      sta   $4184
;      ldy   #$21
;      sty   $4186
;      dey
;      sty   $4186
;      lda   .EnglishResults,X
;      jsr   .GetLoNybble
;      sta   $4184
;      ldy   #$21
;      sty   $4186
;      dey
;      sty   $4186
;      inx
;      beq   .DonePrintingA
;      jmp   .PrinterTestA
;.DonePrintingA


      ldx   #$00
      ldy   #$02
.CompressingLoop
      lda   .EnglishResults,X
      cmp   #$FF
      beq   .ToDoneCompressing
      cmp   #$FE
      beq   .ToDoneCompressing
      cmp   #$FD
      beq   .ToDoneCompressing
      cmp   #$FC
      bne   .NotCompressPeriod
      lda   #$2E
      sta   .DecodedText,Y
      inx
      iny
      jmp   .CompressingLoop
.ToDoneCompressing
      jmp   .DoneCompressing
.NotCompressPeriod
      sta   .TempByte1
      lda   #$00
      sta   .TempData
      inx
      lda   .EnglishResults,X
      cmp   #$FC
      bne   .NoPeriodMid1
      lda   #$06
      sta   .TempByte2
      lda   #$0D
      sta   .TempByte3
      lda   #$23
      sta   .TempByte4
      lda   #$01
      sta   .TempData
      jmp   .DoCompression
.NoPeriodMid1
      sta   .TempByte2
      inx
      lda   .EnglishResults,X

      cmp   #$FC
      bne   .NoPeriodMid2
      lda   .TempByte2
      and   #$F0
      ora   #$06           ;Hopefully, to save the byte's appearance?
      sta   .TempByte2
      lda   #$0D
      sta   .TempByte3
      lda   #$23
      sta   .TempByte4
      lda   #$01
      sta   .TempData
      jmp   .DoCompression
.NoPeriodMid2
      sta   .TempByte3
      inx
      lda   .EnglishResults,X

      cmp   #$FC
      bne   .NoPeriodMid3
      lda   .TempByte3
      and   #%11111100
      ora   #$01
      sta   .TempByte3
      lda   #$01
      sta   .TempData
      lda   #$23
.NoPeriodMid3
      sta   .TempByte4
      inx                     ;Ready for next 4 characters...

.DoCompression
      asl   .TempByte4
      asl   .TempByte4
      asl   .TempByte4
      rol   .TempByte3
      asl   .TempByte4
      rol   .TempByte3
      asl   .TempByte4
      rol   .TempByte3
      rol   .TempByte2
      asl   .TempByte4
      rol   .TempByte3
      rol   .TempByte2
      asl   .TempByte4
      rol   .TempByte3
      rol   .TempByte2
      rol   .TempByte1
      asl   .TempByte4
      rol   .TempByte3
      rol   .TempByte2
      rol   .TempByte1


      lda   .TempByte1
      eor   #$43           ;Exclusive-OR!
      sta   .DecodedText,Y
      iny
      lda   .TempByte2
      eor   #$43
      sta   .DecodedText,Y
      iny
      lda   .TempByte3
      eor   #$43
      sta   .DecodedText,Y
      iny

      lda   .TempData         ;An error flag, here!!!!
      beq   .NoShortError
      lda   #$2E
      sta   .DecodedText,Y
      iny
      jmp   .DoneCompressing
.NoShortError
      jmp   .CompressingLoop


.DoneCompressing
      lda   #$0D
      sta   .DecodedText,Y
      iny
      lda   #$0A
      sta   .DecodedText,Y
      iny
      lda   #$24
      sta   .DecodedText,Y


;      lda #$4              ;Set up another Text writing command (#$04)???
;      ldx #>.DecodedText           ;$8094 for the text, it seems...
;      ldy #<.DecodedText
;.lbl_81d6   jsr $F80C      ;And send the command, my man...

.CopyDataToScreenRam       ;Descriptive, no?
;---------------------------------------------
      lda   #$20           ;Space
      ldx   #$00
      ldy   #$19           ;Clear 25 spaces
.ClearSc1
      sta   .ResultsScreen+191,X
      sta   .ResultsScreen+439,X
      inx
      dey
      bne   .ClearSc1

      ldx   #$00
      ldy   #$0F
.ClearSc2
      sta   .ResultsScreen+315,X
      inx
      dey
      bne   .ClearSc2

;-------------------------------------------
      ldx   #$03
      ldy   #$00
.CopyDataLoop01
      lda   .DecodedText,X
      cmp   #$2E
      beq   .CopyDataFinished1
      sta   .ResultsScreen+192,Y
      iny
      inx
      jmp   .CopyDataLoop01
.CopyDataFinished1
      inx
      ldy   #$00
.CopyDataLoop02
      lda   .DecodedText,X
      cmp   #$2E
      beq   .CopyDataFinished2
      sta   .ResultsScreen+321,Y
      iny
      inx
      jmp   .CopyDataLoop02
.CopyDataFinished2
      inx
      ldy   #$00
.CopyDataLoop03
      lda   .DecodedText,X
      cmp   #$2E
      beq   .CopyDataFinished3
      sta   .ResultsScreen+440,Y
      iny
      inx
      jmp   .CopyDataLoop03

.CopyDataFinished3

      lda   #$04
      ldx   #>.ResultsScreen
      ldy   #<.ResultsScreen
      jsr   $F80C


.ClearBytesAgain
      ldx   #$2E
      lda   #$20
.ClearLoop01
      sta   .EnglishResults,X
      dex
      bne   .ClearLoop01
      ldx   #$40
      lda   #$00
.ClearLoop02
      sta   .DecodedText+1,X
      dex
      bne   .ClearLoop02

.lbl_81e2   jmp .lbl_8172
;--------------------
.Quit_Program
      lda #$2           ;I guess this is command (#$02), to output a single byte...
      ldy #$0           ;As opposed to command (#$04), which prints a string...
      ldx #$d
      jsr $F80C         ;2,0,D does what???
      lda #$2
      ldy #$0
      ldx #$a           ;2,0,A does what???   CRLF?
      jsr $F80C
      lda #$0
      ldy #$0           ;0,0,A???
      jmp $F80C         ;And presumably this ends the program...
