   PROCESSOR 6502
   ORG $8000

      jmp .Start_Code
;--------------------
.EnglishIntro
      dc.b "XiaoNenRen KeyTest Version 1.0"
      dc.b #$0D,#$0A
      dc.b "(C) 1995 by JinRiTong, Inc."
      dc.b #$0D,#$0A
      dc.b "Programming by Tang Ruichun"
      dc.b #$0D,#$0A,#$0A
      dc.b "Type key see Scan/ASCII code"
      dc.b #$0D,#$0A
      dc.b "Type Ctrl-ESC to exit"
      dc.b #$0D,#$0A,#$24
.EnglishResults
      dc.b #$0D,#$0A
      dc.b "Character: xxxx Sc: xx Ch: $"


;This is all Chinese text...
.ChineseIntro
      dc.b #$A1,#$BA,#$D0,#$A1,#$C4
      dc.b $dc
      dc.b #$C8
      dc.b $cb ;?
      dc.b $a1 ;?
      dc.b $bb ;?
      dc.b $bc ;?
      dc.b $fc ;?
      dc.b #$C5
      dc.b #$CC
      dc.b $b2 ;?
      dc.b $e2 ;?
      dc.b #$CA
      dc.b $d4 ;?
      dc.b $b3 ;?
      dc.b $cc ;?
      dc.b #$D0
      dc.b #$F2
      dc.b #$20
      dc.b #$B5
      dc.b #$DA
      dc.b #$31
      dc.b #$2E
      dc.b #$30
      dc.b #$B0
      dc.b #$E6
      dc.b #$0D
      dc.b #$0A
      dc.b #$B1
      dc.b #$B1
      dc.b #$BE
      dc.b #$A9
      dc.b #$BD
      dc.b #$F0
      dc.b #$C8
      dc.b #$D5
      dc.b #$CD
      dc.b #$A8
      dc.b #$B9
      dc.b #$AB
      dc.b #$CB
      dc.b #$BE
      dc.b #$B3
      dc.b #$F6
      dec $b7
      jsr $cc20
      dec $c8
      dc.b #$F0
      dc.b #$B4
      dc.b $ba ;?
      dc.b #$D1
      dc.b #$D0
      dc.b #$D6
      dc.b #$C6
      dc.b #$0D
      dc.b #$0A
      dc.b #$0A
      dc.b #$B0
      dc.b #$B4
      dc.b #$C8
      dc.b #$CE
      dc.b #$D2
      dc.b #$E2
      dc.b $bc ;?
      dc.b $fc ;?
      dc.b $a3 ;?
      ldy $e9b2
      dc.b $bf ;?
      ldy $c9,x
      tay
      dc.b $c3 ;?
      inx
      dc.b $c2 ;?
      dc.b $eb ;?
      dc.b $ba ;?
      cmp $d6d7
      dc.b $b7 ;?
      dc.b $fb ;?
      dc.b $c2 ;?
      dc.b $eb ;?
      ora $b00a
      dc.b #$B4
      dc.b "Ctrl-ESC"

      dc.b $bc ;?
      dc.b $fc ;?
      dc.b $a3 ;?
      ldy $cbcd
      dc.b $b3 ;?
      inc $d,x
      asl
      dc.b #$24
.ChineseResults
      dc.b #$0D
      dc.b #$0A
      dc.b $d7 ;?
      dec $b7,x
      dc.b $fb ;?
      dc.b $3a ;?
      sei
      sei
      sei
      sei
      jsr $a8c9
      dc.b $c3 ;?
      inx
      dc.b $c2 ;?
      dc.b $eb ;?
      dc.b $3a ;?
      sei
      sei
      jsr $d6d7
      dc.b $b7 ;?
      dc.b $fb ;?
      dc.b $3a ;?
      dc.b #$20
      dc.b #$24
      dc.b #$00
;-----------------------------------------------------------------
;-----------------------------------------------------------------
;=================================================================
;
; Here are two subroutines that convert bytes into printable text.
;
;-----------------------------------------------------------------
.GetHiNybble   lsr      ;Gives you the high nybble...
      lsr
      lsr
      lsr
.GetLoNybble   and #$f  ;Gives you the low nybble...
      clc
      adc #$30       ;And converts to a printable number
      cmp #$3a
      bcc .lbl_8154  ;Or HEX, if it's above 9.
.lbl_8151   clc
      adc #$7
.lbl_8154
      rts
;=================================================================
;-----------------------------------------------------------------
;-----------------------------------------------------------------

;The REAL start of the program...
;--------------------------------

.Start_Code
      cli
      lda #$b              ;Command #$0B???
      ldx #$0              ;A command?
      jsr $F80C            ;English or Chinese???
      sta $8143            ;Result stored in $8143... High bit means English/Chinese, apparently.

      lda #$4              ;Command #$04??  Write text???
      ldx #>.EnglishIntro
      ldy #<.EnglishIntro          ;Address to load the English Text ($8003)....
      bit $8143            ;If $8143 is +ve, then...
      bpl .ItsEnglish        ;It's English.
      ldx #>.ChineseIntro
      ldy #<.ChineseIntro          ;Otherwise, load Chinese text at $80B2
.ItsEnglish
      jsr $F80C            ;Send command...
.lbl_8172
      lda #$18
      ldx #$0
      jsr $F800            ;Hmmm... what does this do?
                           ;It seems to get the raw keyboard data in A and X!!!
      tay
      cpy #$1b
      bne .Not_Escape
      cpx #$1
      bne .Not_Escape        ;If it isn't equal to "ESC", then continue....
      lda #$18
      ldx #$2
      jsr $F800            ;Hmm... get more keyboard data?
      and #$4
      bne .Quit_Program    ;If #%00000100, then QUIT! (?)
                           ;Must mean that CTRL is pressed at the same time...?

      ldy #$1b             ;Heh.. puts the correct bytes back secretly..
      ldx #$1              ;This looks like a hack to me...
;--------------------------------------------------------------------
.Not_Escape
      tya                  ;First, we get the low Byte (of the code)
                           ;This appears to represent the ASCII value...
                           ;I could be wrong, of course; let's see below....
      jsr .GetLoNybble
      sta .ChineseResults+10  ;Put Lo nybble in position.. obviously...
      sta .EnglishResults+16 ;So, it goes in both English and Chinese places in RAM...
      tya
      jsr .GetHiNybble
      sta .ChineseResults+9 ;Then put Hi nybble in position...
      sta .EnglishResults+15
      txa                  ;Next, get high Byte of the code...
      jsr .GetLoNybble
      sta .ChineseResults+8  ;Store it in two positions...
      sta .ChineseResults+20
      sta .EnglishResults+14
      sta .EnglishResults+23
      txa
      jsr .GetHiNybble
      sta .ChineseResults+7    ;Yadda yadda...
      sta .ChineseResults+19
      sta .EnglishResults+13
      sta .EnglishResults+22
      tya                  ;Then we get the low byte again...
      pha                  ;Save it for later...
      lda #$4              ;Set up another Text writing command (#$04)???
      ldx #>.EnglishResults           ;$8094 for the text, it seems...
      ldy #<.EnglishResults
      bit $8143            ;Right, again is it Chinese???
      bpl .lbl_81d6        ;If not... don't worry.
      ldx #>.ChineseResults             ;$8126 for the Chinese text...
      ldy #<.ChineseResults
.lbl_81d6   jsr $F80C      ;And send the command, my man...
      pla                  ;Get back that low byte...
      tax
      lda #$1b
      ldy #$0
      jsr $F800            ;WTF?  Get the keyboard data again???
                           ;I have a feeling it waits in $F800 until a key is pressed...

.lbl_81e2   jmp .lbl_8172
;--------------------
.Quit_Program
      lda #$2           ;I guess this is command (#$02), to output a single byte...
      ldy #$0           ;As opposed to command (#$04), which prints a string...
      ldx #$d
      jsr $F80C         ;2,0,D does what???
      lda #$2
      ldy #$0
      ldx #$a           ;2,0,A does what???   CRLF?
      jsr $F80C
      lda #$0
      ldy #$0           ;0,0,A???
      jmp $F80C         ;And presumably this ends the program...
